﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Datetime
{
    public class Sample : ContentPage
    {

        SfChart chart;
        LineSeries columnSeries;
        ObservableCollection<ChartDataPoint> Data;    
        public Sample()
        {

            Data = new ObservableCollection<ChartDataPoint>();

            DateTime start = new DateTime(1970, 1, 1);

            Data.Add(new ChartDataPoint(new DateTime(2010, 1, 1), (new DateTime(2010, 1, 1, 1, 0, 0) - start).TotalMilliseconds));
            Data.Add(new ChartDataPoint(new DateTime(2010, 2, 1), (new DateTime(2010, 1, 1, 2, 0, 0) - start).TotalMilliseconds));
            Data.Add(new ChartDataPoint(new DateTime(2010, 3, 1), (new DateTime(2010, 1, 1, 3, 0, 0) - start).TotalMilliseconds));
            Data.Add(new ChartDataPoint(new DateTime(2010, 4, 1), (new DateTime(2010, 1, 1, 4, 0, 0) - start).TotalMilliseconds));
            Data.Add(new ChartDataPoint(new DateTime(2010, 5, 1), (new DateTime(2010, 1, 1, 5, 0, 0) - start).TotalMilliseconds));

            chart = new SfChart();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;
            chart.Title.Text = "Chart";

            DateTimeAxis xAxis = new DateTimeAxis();
            xAxis.LabelStyle.LabelFormat = "MMM:yyyy";
            chart.PrimaryAxis = xAxis;

            NumericalAxis yAxis = new NumericalAxis();
            yAxis.LabelCreated += YAxis_LabelCreated;
            yAxis.Interval = 3600000;
            NumericalStripLine stripLine = new NumericalStripLine();
            stripLine.Start = (new DateTime(2010, 1, 1, 3, 0, 0 ) - start).TotalMilliseconds;
            stripLine.Width = (new DateTime(2010, 1, 1, 3, 0, 0) - start).TotalMilliseconds - (new DateTime(2010, 1, 1,2, 0, 0) - start).TotalMilliseconds;
            stripLine.FillColor = Color.Aqua;
            yAxis.StripLines.Add(stripLine);

            chart.SecondaryAxis = yAxis;

            columnSeries = new LineSeries();
            columnSeries.ItemsSource = Data;
            chart.Series.Add(columnSeries);

            Content = chart;
        }

        private void YAxis_LabelCreated(object sender, ChartAxisLabelEventArgs e)
        {
            double Value = Convert.ToDouble(e.LabelContent);
        
            DateTime date =(new DateTime(1970, 1, 1).AddMilliseconds(Value));
            e.LabelContent = String.Format("{0:HH:mm}", date);
        }        
    }
}
